﻿using System;
using System.Runtime.InteropServices;

class Program
{
    public struct MyStruct
    {
        public uint n1;
        public uint n2;
    }

    [DllImport("Win32Project1.dll", SetLastError = true)]
    internal static unsafe extern int TestCall(IntPtr ptr1, ref IntPtr ptr2, string txt, ref MyStruct structPtr, ref MyStruct* pStructPtr, uint mark);

    unsafe static void Main(string[] args)
    {
        // Console.ReadLine();
        MyStruct m1 = new MyStruct();
        m1.n1 = 0x1fffffff;
        m1.n2 = 0x1eeeeeee;

        MyStruct m2 = new MyStruct();
        m2.n1 = 0x2fffffff;
        m2.n2 = 0x2eeeeeee;

        uint mark = 0x55555555;

        fixed (int* pInt1 = &Program.int1)
        fixed (int* pInt2 = &Program.int2)
        {
            IntPtr ptr1 = new IntPtr(pInt1);
            IntPtr ptr2 = new IntPtr(pInt2);

            Console.WriteLine("pInt1 == " + ptr1.ToInt64().ToString("x"));
            Console.WriteLine("pInt2 == " + ptr2.ToInt64().ToString("x"));

            string test = " 1 1 1 1 1 1 1 1 1";

            MyStruct* pM2Struct = &m2;

            IntPtr ptr3 = new IntPtr(pM2Struct);
            Console.WriteLine("pM2Struct == " + ptr3.ToInt64().ToString("x"));
            Console.WriteLine("------------------ managed to native --------------------");
            TestCall(ptr1, ref ptr2, test, ref m1, ref pM2Struct, mark);
            Console.WriteLine("------------------ native to managed --------------------");

            Console.WriteLine();
            Console.WriteLine();

            Console.WriteLine("Program.int1 == " + Program.int1.ToString("x"));
            Console.WriteLine("Program.int2 == " + Program.int2.ToString("x"));
            Console.WriteLine("ptr2 == " + ptr2.ToInt64().ToString("x"));
            Console.WriteLine("*ptr2 == " + (*(int *)ptr2.ToPointer()).ToString("x"));
            Console.WriteLine();

            Console.WriteLine("m1.n1 == " + m1.n1.ToString("x"));
            Console.WriteLine("m1.n2 == " + m1.n2.ToString("x"));
            Console.WriteLine();

            Console.WriteLine("m2.n1 == " + m2.n1.ToString("x"));
            Console.WriteLine("m2.n2 == " + m2.n2.ToString("x"));
            Console.WriteLine("pM2Struct->n1 == " + pM2Struct->n1.ToString("x"));
            Console.WriteLine("pM2Struct->n2 == " + pM2Struct->n2.ToString("x"));

            //{
            //    test = new string('c', 0x1000);
            //    Console.WriteLine("------------------ managed to native --------------------");
            //    TestCall(ptr1, ref ptr2, test, ref m1, ref pM2Struct, mark);
            //    Console.WriteLine("------------------ native to managed --------------------");
            //}
        }


        Console.WriteLine("Press any key to exit...");
        Console.ReadLine();
    }

    static int int1 = 0x10203040;
    static int int2 = 0x59887766;
}
